#include "RegisterUserWindow.h"

using namespace FS;

RegisterUserWindow::RegisterUserWindow(ApplicationNode *applicationNode, QWidget* parent)
: QMainWindow(parent)
{
	this->applicationNode = applicationNode;
	ui.setupUi(this);

	QObject::connect(ui.buttonBox, SIGNAL(rejected ()), applicationNode, SLOT(Quit()));
	QObject::connect(ui.buttonBox, SIGNAL(accepted ()), this, SLOT(AcceptUserData()));
	QObject::connect(ui.usernameLineEdit, SIGNAL(returnPressed ()), this, SLOT(AcceptUserData()));
	QObject::connect(ui.passwordLineEdit, SIGNAL(returnPressed ()), this, SLOT(AcceptUserData()));
	string temp = "v";
	temp = temp + PRODUCTVER;
	ui.versionNo->setText(QString(temp.c_str()));
}

RegisterUserWindow::~RegisterUserWindow()
{
	QObject::disconnect(ui.buttonBox, SIGNAL(rejected ()));
	QObject::disconnect(ui.buttonBox, SIGNAL(accepted ()));
	QObject::disconnect(ui.usernameLineEdit, SIGNAL(returnPressed ()));

	cout << "Destroying RegisterUserWindow"<<endl;
}

void RegisterUserWindow::showFullScreenAndClear()
{
	ui.passwordLineEdit->clear();
	ui.usernameLineEdit->clear();
	ui.usernameLineEdit->setFocus();
	showFullScreen();
}

void RegisterUserWindow::AcceptUserData()
{
	if (!applicationNode->getLoginPressedOk())
	{
		applicationNode->setLoginPressedOk(true);

		if((ui.usernameLineEdit->text()!="") && (ui.passwordLineEdit->text()!=""))
		{
			try
			{
				applicationNode->RegisterUser(ui.usernameLineEdit->text(),ui.passwordLineEdit->text());
			}
			catch(const ApplicationNode::ApplicationNodeException &e)
			{
				applicationNode->restoreNormalCursor();
				switch(QMessageBox::warning(NULL,tr("Warning!"),
						tr("Database connection not possible, please check user name and password."),
						QMessageBox::Ok))
				{
				case QMessageBox::Ok:
					applicationNode->restoreOverrideCursor();
					ui.passwordLineEdit->clear();
					ui.usernameLineEdit->clear();
					ui.usernameLineEdit->setFocus();
				default:
					applicationNode->setLoginPressedOk(false);
					return;
				}
			}
		}
		else if((ui.usernameLineEdit->text()!="") && (ui.passwordLineEdit->text()==""))
		{
			QMessageBox::warning( this, "FsWisdom",
					"\nPlease enter password!\n");
			ui.passwordLineEdit->setFocus();
			applicationNode->setLoginPressedOk(false);
		}
		else{
			QMessageBox::warning( this, "FsWisdom",
					"\nPlease enter user name!\n");
			ui.usernameLineEdit->setFocus();
			applicationNode->setLoginPressedOk(false);
		}
	}
}

